//  Dart это объектно-ориентированный язык, который основан на классах, унаследование и примесей.
// Все что можно поместить в переменную является объектом.
// Dart потдерживает универсальные типы, т.е. у него есть джейнерики(хз что это)
// В отличие от java, dart нет ключевых слов public, protected, privat, вместо этого у него ставится "_name"
// dart потдерживает функции верхнего уровня, такие как main 



// ФУНКЦИЯ MAIN
// Каждое приложение dart имеет top-level функцию main, которая управляет и является входной точкой для приложения.
// По умолчанию возвращает тип void и принимает в себя тип строк.


// создал функцию аля запрос с сервера который передает переменную double, для того чтоб передать ее в numValue. относится к теме числа
double getValueFromServer(){
  return 12.55;
}

void main() {
  // Типы данных:
  // ЧИСЛА
  var number = 0;

  // int-тип целое число
  int intValue = 444; 

  // double-тип число c плавающей точкой
  double doubleValue = 12.9; 
  
  // num-тип который может принимать и целое число и число с плавающей точкой, для примера использовал функцию, который осужествляет запрос на сервер
  num numValue = getValueFromServer(); 

  // метод print выводит в консоль значение, которое установлено в скобках.
  print('Начало Вывода чисел');
  print('----------------');
  print(number.runtimeType);
  print(intValue.runtimeType); 
  print(doubleValue.runtimeType);
  print(numValue.runtimeType);
  print('----------------');
  print('Конец Вывода чисел');

  print('===================');

  // СТРОКИ
  String stringValue = 'Изучаем Dart';
  // интрополяция строк
  int numForString = 9989;

  print('Начало вывода строк');
  print('----------------');
  print(stringValue);
  
  // интрополяция строк
  print("${stringValue.toUpperCase()} - ${numForString}");
  
  // преобразование строку в тип и наоборот(например из string в integer)
  print(1111 == int.parse('1111')); // выведет true так как 1111 = 1111
  
  // проверка duble gjcле преобразования строки в double
  print(11.11 == double.parse('11.11')); // результатом выведет true

  // теперь переводим integer в string
  print(1.toString() == '1'); // результатом выведет true
  
  // теперь переводим double в string
  print(11.11.toString() == '11.11');  // результатом выведет true

  // теперь переведем double c округлением до 2 знаков ну и проверка
  print(11.11111.toStringAsFixed(2) == '11.12'); // результатом выведет false так как 11.11111 округленная до 2 чисел не будет равно 11.12
  
  print('----------------');
  print('Конец вывода строк');
  print('===================');
  

}